<?php

// used in the recursion
$pool = array();
$rec_counter = 0;

/* recursively scan a file for includes */
function find_includes($filename) {
	global $pool, $rec_counter;

	// read the file into an array
	$fa = file($filename);

	// include the current file
	$pool['"'.$filename.'"'] = true;
	foreach ($fa as $line_num => $line) {
		// find our includes
	   $filepath = trim(preg_replace('/.*(include|require)(_once)?\\s*\(?\s*("|\\\')([^\'"]+).*|.*/','$4',$line));
		if(strcmp("", trim($line)) == 0)
			continue;
		
		$ok = false;

		// and check if they are real files
		if(is_file($filepath)) { // absolute path
# 			echo "absolute: $filepath (".dirname($filename).")\n";
			$ok = true;
		} else { // relative to current document
			$filepath_rel = dirname($filename)."/".$filepath;
			if(is_file($filepath_rel)) {
				$filepath = $filepath_rel;
				$ok = true;
# 				echo "rel: $filepath \n";
			} else { // using PHP2_INCLUDE_PATH
				if(isset($_ENV['PHP2_INCLUDE_PATH'])) {
					$filepath_inc = $_ENV['PHP2_INCLUDE_PATH'].$filepath;
					if(is_file($filepath_inc)) {
						$filepath = $filepath_inc;
						$ok = true;
# 						echo "var: $filepath \n";
					}
				}
			}
		}
		//PHP2_INCLUDE_PATH
		
			
		if($ok) {
			if(!isset($pool['"'.$filepath.'"'])) {
				// store the files we already collected, this sorts out duplicates
				$pool['"'.$filepath.'"'] = true;
				find_includes($filepath, dirname($filepath), $pool);
			}
		}
	}
}

$make_snippet_counter = 0;
function make_snippet($matches) {
	$res = "";
	for($i=1; $i < count($matches); $i++) {
		global $make_snippet_counter;
		$make_snippet_counter = $make_snippet_counter + 1;
		$res .= '\\$${'.$make_snippet_counter.':'.$matches[$i]."}";
	}
	return $res;
}
	
function parse_ctags($filename) {
	global $pool;
	
	//find included/required files
	find_includes($filename);
	$includes = implode(" ", array_keys($pool));

	// now let ctags scan all those files and not generate duplicate warnings
	// Note: exec didn't work as expected on my system
	$command = "ctags -wx $includes";
		
	ob_start();
	passthru($command);
	$ctags = ob_get_contents();
	ob_end_clean();
	
	// generate an array from the ctags output
	$la = explode("\n", $ctags);
	return $la;
}

?>